﻿Type=Class
Version=6.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
Sub Class_Globals
	Private ignore As Button
	Private pnColor, btColor, txColor, pRow, pCol, bSize, fWid, fHgt, fGap, txSize, btWid, btRect  As Int
	Private swMax, swInit, swPhone, swWide  As Boolean
		
	Public lf, tp, wd, ht 		As Int
	Public tButtonText() 		As String
	Public tButtonTag() 		As String
	Public tButtonColor() 		As Int
	Public tButtonTextColor() 	As Int
	
	Private pnTextSw			As Boolean
	Private pnHead   			As String 	= ""
	Private pnHeadHt 			As Int 		= 0
	Private pnHeadSz 			As Int  	= 20
	Private cEvent 				As String 	= ""
	Private cCall  				As Object
	Private pnText   			As String
	Private pnTextHt 			As Int 		= 0
	Private pnTextSz 			As Int  	= 14
	Private pnTextWd 			As Int
	
	btColor = Colors.White
	txColor = Colors.Black
	pnColor = Colors.Green
	
	pRow    = 3
	pCol	= 3
	fGap    = 10
	txSize 	= 15
	btRect 	= 0
	bSize  	= 100
	btWid   = 100
	swPhone = True
	swInit  = False
	swMax   = True
	swWide 	= False
	pnTextSw = False
	
End Sub

'The Left, Top, Width & Height (LF,TP,WD,HT) will Put Panel inCenter of Screne
Sub Panel_Rtn(NumberOfRows As Int, NumberofColumns As Int, ButtonTextSize As Int ) As Panel
	pRow 	= NumberOfRows
	pCol 	= NumberofColumns
	txSize 	= ButtonTextSize
	
	Private hgt, col, ctr, num 	As Int = 0
	Private pn 		 			As Panel

	btWid = bSize
	
	If swMax = False And btRect <> 0 Then btWid = bSize + btRect
	
	If swPhone Then
		If swMax Then
			If swWide Then 
				hgt = fHgt
				col = pRow 
			  Else 
			  	hgt = fWid
				col = pCol
			End If
		
			
			hgt 	= hgt - (fGap * (col + 1)) - pnHeadHt - pnTextHt
			bSize 	= hgt / col
			btWid   = bSize
		End If
	End If
	
	wd = (btWid * pCol) + (fGap * (pCol + 1))
	ht = (bSize * pRow) + (fGap * (pRow + 1)) + pnHeadHt + pnTextHt
	
	
	tp = fGap + pnHeadHt + pnTextHt
	lf = fGap

	num = pnText.Length * (pnTextSz + 5)
	
	If num > wd Then num = wd 

	pnTextWd = num
			
	pn.Initialize("")
	pn.Color = pnColor
								
	For i = 0 To pRow - 1
		For j = 0 To pCol - 1
			If tButtonColor.Length <> 0 Then 
				If ctr < tButtonColor.Length Then btColor = tButtonColor(ctr)
			End If
			
			If tButtonTextColor.Length <> 0 Then
				If ctr < tButtonTextColor.Length Then txColor = tButtonTextColor(ctr)
			End If
			
			Dim b As Button
			b.Initialize("Button") 'All buttons share the same event sub
			b.TextColor	= txColor
			b.Color 	= btColor
			b.Text		= tButtonText(ctr)
			b.Tag		= tButtonTag(ctr)
			b.Padding 	= Array As Int (0,0,0,0)
			b.textsize  = txSize
			pn.AddView(b,lf,tp,btWid,bSize)
			lf = lf + fGap + btWid
			ctr = ctr + 1
		Next
		
		tp = tp + fGap + bSize
		lf = fGap
	Next
	
	
	If pnHeadHt <> 0 Then
		Dim e As Label
		e.Initialize("")
		e.Gravity	= Bit.Or(Gravity.TOP, Gravity.CENTER)
		e.TextColor	= txColor
		e.Color 	= pnColor
		e.Text		= pnHead
		e.Padding 	= Array As Int (0,0,0,0)
		e.textsize  = pnHeadSz
		pn.AddView(e,0,0,wd,pnHeadHt)
	End If
	
	If pnHeadHt <> 0 Then
		Dim t As EditText
		t.Initialize("")
		t.TextColor	= txColor
		t.Color 	= btColor
		t.Text		= pnText
		t.Padding 	= Array As Int (0,0,0,0)
		t.textsize  = pnTextSz
		num = (wd - pnTextWd) / 2
		If num < 0 Then num = 0
		pn.AddView(t,num,5+pnHeadHt,pnTextWd,pnTextHt)
	End If
	
	tp = (fHgt - ht) / 2
	lf = (fWid - wd) / 2
	
	Return pn
End Sub


'/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\


#Region ----- Events -----

Private Sub Button_Click
	Dim b As Button
	b = Sender
	
	Log("You Pressed Tag: " & b.Tag)

	ToastMessageShow("You Pressed " & b.Text & ", Tag: " & b.Tag,True)

	If SubExists(cCall, cEvent & "_Click") Then
		CallSub2(cCall, cEvent & "_Click",Sender)
	End If
End Sub

'----------------------------------

Private Sub Button_LongClick As Button
	Dim b As Button
	b = Sender

	ToastMessageShow("You Pressed " & b.Text & ", Tag: " & b.Tag,True)

	If SubExists(cCall, cEvent & "_LongClick") Then
		CallSub2(cCall, cEvent & "_LongClick",Sender)
	End If
End Sub


#End Region


'/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\


#region ---------- Getable Paramaters ----------


'Returns Button Size in Pixels
Sub GetButtonSize As Int
	Return bSize
End Sub


#End Region


'/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\


#Region ---------- Setable Parameters ----------


'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(callBack As Object, callEvent As String, w As Int, h As Int) As Boolean
	If swInit Then Return swInit
		
	swInit 	= True
	fWid 	= w
	fHgt 	= h
	cCall	= callBack
	cEvent 	= callEvent
	
	If fWid > fHgt Then swWide = True Else swWide = False
	
	Return swInit
End Sub

'-----------------------------------------

'Place a Edit Text Box at Top of Buttons (ie Calculator); Default: None
Sub SetTextBox(textName As String, textHeigt As Int, textSize As Int, swVisible As Boolean)
	pnText   = textName
	pnTextHt = textHeigt
	pnTextSz = textSize
	pnTextSw = swVisible
End Sub

'-----------------------------------------

'Place a Heading at Top of Panel; Default: None
Sub SetHeader(HeadName As String, HeadHeigt As Int,HeadTextSize As Int)
	pnHead 	 = HeadName
	pnHeadHt = HeadHeigt
	pnHeadSz = HeadTextSize
End Sub

'-----------------------------------------

'Set Space between Buttons in Pixels; Default: 10 pixels
Sub SetSpaceBetweenButtons(GapWidth As Int)
	fGap = GapWidth
End Sub

'-----------------------------------------

'Button Size in Pixels; Use 0 for Max size for Device Width (Default)
Sub SetButtonSize(ButtonSize As Int)
	bSize = ButtonSize
	
	If bSize = 0 Then swMax = True Else swMax = False
End Sub
'-----------------------------------------

'Offset in Pixels to Make Rectangle (add to Button Width)
Sub SetRectangleOffset(OffsetSize As Int)
	btRect = OffsetSize
End Sub

'-----------------------------------------


'Defaults: Green, White, Black; Use 0 to Leave one unchanged
Sub SetColors(PanelColor As Int, ButtonColor As Int, TextColor As Int)
	If PanelColor <> 0  Then pnColor = PanelColor
	If ButtonColor <> 0 Then btColor = ButtonColor
	If TextColor <> 0   Then txColor = TextColor
	
End Sub

'-----------------------------------------

#end region
